/*----- PROTECTED REGION ID(Keithley2001.cpp) ENABLED START -----*/
static const char *RcsId = "$Id:  $";
//=============================================================================
//
// file :        Keithley2001.cpp
//
// description : C++ source for the Keithley2001 class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Keithley2001 are implemented in this file.
//
// project :     Keithley 2001
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include "Keithley2001.h"
#include "Keithley2001Class.h"
#include <PogoHelper.h>
#include <yat4tango/Logging.h>
#include <yat4tango/DeviceInfo.h>
#include <yat/utils/XString.h>
#include <yat/Portability.h>    //- NaN

/*----- PROTECTED REGION END -----*/	//	Keithley2001.cpp

/**
 *  Keithley2001 class description:
 *    Class to monitor the temperature from a Keithley2001
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name   |  Method name
//================================================================
//  State          |  dev_state
//  Status         |  Inherited (no method)
//  SaveConfig     |  save_config
//  RestoreConfig  |  restore_config
//================================================================

//================================================================
//  Attributes managed is:
//================================================================
//  temperature  |  Tango::DevDouble	Scalar
//================================================================

namespace Keithley2001_ns
{
/*----- PROTECTED REGION ID(Keithley2001::namespace_starting) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	Keithley2001::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : Keithley2001::Keithley2001()
 *	Description : Constructors for a Tango device
 *                implementing the classKeithley2001
 */
//--------------------------------------------------------
Keithley2001::Keithley2001(Tango::DeviceClass *cl, string &s)
 : Tango::Device_4Impl(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Keithley2001::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Keithley2001::constructor_1
}
//--------------------------------------------------------
Keithley2001::Keithley2001(Tango::DeviceClass *cl, const char *s)
 : Tango::Device_4Impl(cl, s)
{
	/*----- PROTECTED REGION ID(Keithley2001::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Keithley2001::constructor_2
}
//--------------------------------------------------------
Keithley2001::Keithley2001(Tango::DeviceClass *cl, const char *s, const char *d)
 : Tango::Device_4Impl(cl, s, d)
{
	/*----- PROTECTED REGION ID(Keithley2001::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Keithley2001::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : Keithley2001::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Keithley2001::delete_device()
{
	DEBUG_STREAM << "Keithley2001::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(Keithley2001::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	delete_task();

  //- Scalar Attributes
  DELETE_SCALAR_ATTRIBUTE(attr_temperature_read);

	yat4tango::Logging::release(this);
  yat4tango::DeviceInfo::release(this);

	/*----- PROTECTED REGION END -----*/	//	Keithley2001::delete_device
}

//--------------------------------------------------------
/**
 *	Method      : Keithley2001::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void Keithley2001::init_device()
{
	DEBUG_STREAM << "Keithley2001::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(Keithley2001::init_device_before) ENABLED START -----*/
	m_initDone = false;
	m_status.clear();
	
	//	Initialization before get_device_property() call
  yat4tango::DeviceInfo::initialize( this, YAT_XSTR(PROJECT_NAME), YAT_XSTR(PROJECT_VERSION) );
  yat4tango::Logging::initialize(this);
	
	/*----- PROTECTED REGION END -----*/	//	Keithley2001::init_device_before
	

	//	Get the device properties from database
	get_device_property();
	

	/*----- PROTECTED REGION ID(Keithley2001::init_device) ENABLED START -----*/
	
	//	Initialize device
  //- Scalar Attributes
  CREATE_SCALAR_ATTRIBUTE(attr_temperature_read);

  try
  {
	  //- create thread
	  create_task();

		if(m_task_ptr)
		{
		  //- start thread
			m_task_ptr->go();
    }
	}
	catch(...)
	{
		delete_task();
	}
	/*----- PROTECTED REGION END -----*/	//	Keithley2001::init_device
}

//--------------------------------------------------------
/**
 *	Method      : Keithley2001::get_device_property()
 *	Description : Read database to initialize property data members.
 */
//--------------------------------------------------------
void Keithley2001::get_device_property()
{
	/*----- PROTECTED REGION ID(Keithley2001::get_device_property_before) ENABLED START -----*/
	
	//	Initialize property data members
	communicationLink.clear();
	configuration.clear();
	
	/*----- PROTECTED REGION END -----*/	//	Keithley2001::get_device_property_before


	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("CommunicationLink"));
	dev_prop.push_back(Tango::DbDatum("Configuration"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on Keithley2001Class to get class property
		Tango::DbDatum	def_prop, cl_prop;
		Keithley2001Class	*ds_class =
			(static_cast<Keithley2001Class *>(get_device_class()));
		int	i = -1;

		//	Try to initialize CommunicationLink from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  communicationLink;
		else {
			//	Try to initialize CommunicationLink from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  communicationLink;
		}
		//	And try to extract CommunicationLink value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  communicationLink;

		//	Try to initialize Configuration from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  configuration;
		else {
			//	Try to initialize Configuration from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  configuration;
		}
		//	And try to extract Configuration value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  configuration;

	}

	/*----- PROTECTED REGION ID(Keithley2001::get_device_property_after) ENABLED START -----*/
	
	//	Check device property data members init
  //-	create properties if not exist
  std::size_t idx = -1;
  Tango::DbData data_put;
  if (dev_prop[++idx].is_empty()==true)
  {
	  Tango::DbDatum	propert("CommunicationLink");
	  propert	<<	communicationLink;
	  data_put.push_back(propert);
  }
  if (dev_prop[++idx].is_empty()==true)
  {
  	configuration.push_back("# Enter here the list of configuration commands.");
  	configuration.push_back("# Note : commented lines begins with a \"#\" character.");

	  Tango::DbDatum	propert("Configuration");
	  propert	<<	configuration;
	  data_put.push_back(propert);
  }

  //- copy the new propertie(s) if not defined
  if( !data_put.empty() )
  {
	  get_db_device()->put_property(data_put);
  }
	
	/*----- PROTECTED REGION END -----*/	//	Keithley2001::get_device_property_after
}

//--------------------------------------------------------
/**
 *	Method      : Keithley2001::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void Keithley2001::always_executed_hook()
{
	// INFO_STREAM << "Keithley2001::always_executed_hook()  " << device_name << endl;
	/*----- PROTECTED REGION ID(Keithley2001::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	
	/*----- PROTECTED REGION END -----*/	//	Keithley2001::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : Keithley2001::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void Keithley2001::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	// DEBUG_STREAM << "Keithley2001::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Keithley2001::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Keithley2001::read_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute temperature related method
 *	Description: The measured temperature value in degre Celsius
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Keithley2001::read_temperature(Tango::Attribute &attr)
{
	// DEBUG_STREAM << "Keithley2001::read_temperature(Tango::Attribute &attr) entering... " << endl;
	/*----- PROTECTED REGION ID(Keithley2001::read_temperature) ENABLED START -----*/
	if ( m_task_ptr )
	{
		*attr_temperature_read = m_task_ptr->get_data();
	}
	else
	{
	  *attr_temperature_read = yat::IEEE_NAN;		
	}
	//	Set the attribute value
	attr.set_value(attr_temperature_read);
	
	/*----- PROTECTED REGION END -----*/	//	Keithley2001::read_temperature
}

//--------------------------------------------------------
/**
 *	Method      : Keithley2001::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void Keithley2001::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Keithley2001::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	Keithley2001::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command State related method
 *	Description: This command gets the device state (stored in its device_state data member) and returns it to the caller.
 *
 *	@returns Device state
 */
//--------------------------------------------------------
Tango::DevState Keithley2001::dev_state()
{
	// DEBUG_STREAM << "Keithley2001::State()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Keithley2001::dev_state) ENABLED START -----*/
	
	Tango::DevState	argout = Tango::UNKNOWN; // replace by your own algorithm
	//	Add your own code
	if ( communicationLink.empty() )
	{
		argout   = Tango::FAULT;
		m_status = "CommunicationLink property is empty!";
	}
	else if ( !m_task_ptr )
	{
		argout   = Tango::FAULT;
		m_status = "Device initialization failed : no proxy created.";
	}
	else
	{
		try
		{
	  	//- check device communication state
	    argout = m_task_ptr->get_state_status(m_status);
  	}
  	catch(...)
  	{
			argout   = Tango::FAULT;
			m_status = "Cannot read back communication device state.";  		
  	}
	}
	
  set_status(m_status.c_str());
	
	/*----- PROTECTED REGION END -----*/	//	Keithley2001::dev_state
	set_state(argout);    // Give the state to Tango.
	if (argout!=Tango::ALARM)
		DeviceImpl::dev_state();
	return get_state();  // Return it after Tango management.
}

//--------------------------------------------------------
/**
 *	Command SaveConfig related method
 *	Description: This command saves the current Keithley configuration in an available memory slot. <Br>
 *               - No extended memory : slot 0 only                     <Br>
 *               - Model 2001-MEME1 : from 0 to 4                     <Br>
 *               - Model 2001-MEME2 : from 0 to 9                     <Br>
 *               <Br>
 *               NOTE : the current model has no extended memory (only slot0 is available).
 *
 */
//--------------------------------------------------------
void Keithley2001::save_config()
{
// 	DEBUG_STREAM << "Keithley2001::SaveConfig()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Keithley2001::save_config) ENABLED START -----*/
	
	//	Add your own code
  try
  {
    if ( m_task_ptr )
    {
      //- send command
      m_task_ptr->save_configuration();
    }
  }
  catch(Tango::DevFailed& df)
  {
    ERROR_STREAM << "Failed to save current Keithley configuration :\n" << df << std::endl;
    throw;
  }
	
	/*----- PROTECTED REGION END -----*/	//	Keithley2001::save_config
}
//--------------------------------------------------------
/**
 *	Command RestoreConfig related method
 *	Description: This command restores the previously saved Keithley configuration from an available memory slot. <Br>
 *               - No extended memory : slot 0 only                     <Br>
 *               - Model 2001-MEME1 : from 0 to 4                     <Br>
 *               - Model 2001-MEME2 : from 0 to 9                     <Br>
 *               <Br>
 *               NOTE : the current model has no extended memory (only slot0 is available).
 *
 */
//--------------------------------------------------------
void Keithley2001::restore_config()
{
// 	DEBUG_STREAM << "Keithley2001::RestoreConfig()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Keithley2001::restore_config) ENABLED START -----*/
	
	//	Add your own code
  try
  {
    if ( m_task_ptr )
    {
      //- send command
      m_task_ptr->restore_configuration();
    }
  }
  catch(Tango::DevFailed& df)
  {
    ERROR_STREAM << "Failed to save current Keithley configuration :\n" << df << std::endl;
    throw;
  }
	
	/*----- PROTECTED REGION END -----*/	//	Keithley2001::restore_config
}

/*----- PROTECTED REGION ID(Keithley2001::namespace_ending) ENABLED START -----*/

//	Additional Methods

// ============================================================================
// Keithley2001::create_task :
// ============================================================================
void Keithley2001::create_task()
{
  if ( !communicationLink.empty() )
  {
    try
    {
    	m_task_ptr.reset(new KeithleyManager(this, communicationLink, configuration));
    }
    catch(Tango::DevFailed& df)
    {
      FATAL_STREAM << "FATAL create_proxy failed :\n" << df << std::endl;
      delete_task();
    }
  }
}

// ============================================================================
// Keithley2001::delete_task :
// ============================================================================
void Keithley2001::delete_task()
{
	//- Stop monitoring
	m_task_ptr.reset();
}

/*----- PROTECTED REGION END -----*/	//	Keithley2001::namespace_ending
} //	namespace
